package net.mc_pandacraft.java.plugin.pandacraftutils.modules;

import java.util.Date;
import java.util.LinkedList;
import java.util.Queue;

import net.mc_pandacraft.java.plugin.pandacraftutils.PandacraftUtils;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.scoreboard.DisplaySlot;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Score;
import org.bukkit.scoreboard.Scoreboard;

public class StaffQueueManager implements Listener {
	
	private PandacraftUtils plugin = PandacraftUtils.getInstance();
	
	
	public Queue<WaitingPlayer> playerQueue = new LinkedList<WaitingPlayer>();
	
	private Scoreboard scoreboardPlayerQueue = Bukkit.getScoreboardManager().getNewScoreboard();
	
	
	public StaffQueueManager() {
		plugin.getServer().getPluginManager().registerEvents(this, plugin);
	}
	
	
	public WaitingPlayer getWaitingPlayer(String p) {
		for (WaitingPlayer wp : playerQueue)
		{
			if (wp != null && wp.getPlayerName().equalsIgnoreCase(p))
				return wp;
		}
		return null;
	}
	
	
	public WaitingPlayer getWaitingPlayer(OfflinePlayer p) {
		return getWaitingPlayer(p.getName());
	}
	
	
	
	
	public int getPlayerPosition(OfflinePlayer p) {
		int i = 0;
		for (WaitingPlayer wp : playerQueue)
		{
			i++;
			if (wp != null && wp.getPlayerName().equalsIgnoreCase(p.getName()))
				return i;
		}
		return -1;
	}
	

	
	public void removePlayer(String p) {
		WaitingPlayer wp = getWaitingPlayer(p);
		if (wp != null)
		{
			playerQueue.remove(wp);
			updateScoreBoardWaitingList();
		}
	}
	public void removePlayer(OfflinePlayer p) {
		removePlayer(p.getName());
		updateScoreBoardWaitingList();
	}
	
	
	
	
	
	
	
	
	
	
	
	public void updateScoreBoardWaitingList() {
		Objective obj = scoreboardPlayerQueue.getObjective("file_attente");
		if (obj != null)
			obj.unregister();
		
		
		obj = scoreboardPlayerQueue.registerNewObjective("file_attente", "dummy");
		obj.setDisplayName(ChatColor.GOLD+"File d'attente staff");
		obj.setDisplaySlot(DisplaySlot.SIDEBAR);
		
		int i=0;
		for (WaitingPlayer wp : playerQueue) {
			i++;
			
			Player p = plugin.getServer().getPlayerExact(wp.getPlayerName());
			String name;
			if (p == null || !p.isOnline())
				name = wp.getPlayerName();
			else
				name = p.getPlayerListName();
			
			String line = i+"."+name;
			int boardPos = playerQueue.size()-i+1;
			
			
			Score score = obj.getScore(plugin.getServer().getOfflinePlayer(line.substring(0, (line.length()>16)?16:line.length())));
			
			score.setScore(boardPos);
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent event) {
		Player p = event.getPlayer();
		if (p.hasPermission("pandacraft.grade.staff"))
			p.setScoreboard(scoreboardPlayerQueue);
		plugin.getServer().getScheduler().runTaskLater(plugin, new Runnable() {
			@Override public void run() { updateScoreBoardWaitingList(); }
		}, 2L);
		
	}
	
	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent event) {
		plugin.getServer().getScheduler().runTaskLater(plugin, new Runnable() {
			@Override public void run() { updateScoreBoardWaitingList(); }
		}, 2L);
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public class WaitingPlayer {
		
		private String player;
		private String message;
		private Date creationDate;
		private Location location;
		
		
		public WaitingPlayer(String p, String m, Location l) {
			
			player = p;
			message = m;
			creationDate = new Date();
			location = l;
		}
		
		
		public String getPlayerName() { return player; }
		
		public String getMessage() { return message; }
		
		public Date getDate() { return creationDate; }
		
		public Location getLocation() { return location; }
	}
}
